/*
 * This file is part of libphidget21
 *
 * Copyright 2006-2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see 
 * <http://www.gnu.org/licenses/>
 */

#ifndef __MACUSB
#define __MACUSB

#include "cphidget.h"

#ifndef _IPHONE
#include <IOKit/IOKitLib.h>
#include <IOKit/IOCFPlugIn.h>
#include <IOKit/usb/IOUSBLib.h>
#include <IOKit/pwr_mgt/IOPMLib.h>
#include <IOKit/IOMessage.h>
#endif

#ifndef EXTERNALPROTO
int getDevice(CPhidgetHandle phid, io_service_t usbDevice);
int CPhidgetManager_setupNotifications(CFRunLoopRef runloop);
int CPhidgetManager_teardownNotifications();
int reenumerateDevice(CPhidgetHandle phid);
int refreshLabelString(CPhidgetHandle phid);
#endif

#endif
