/*
 * This file is part of libphidget21
 *
 * Copyright 2006-2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see 
 * <http://www.gnu.org/licenses/>
 */

#ifndef GETADDRINFO_H_
#define GETADDRINFO_H_

#ifdef __CYGWIN__
#if 0
//typedef unsigned int socklen_t;
#endif

struct addrinfo {
	int ai_family;
	int ai_socktype;
	int ai_protocol;
	struct sockaddr *ai_addr;
	struct addrinfo *ai_next;
	socklen_t ai_addrlen;
};
#endif

#ifndef _MSC_EXTENSIONS
char *gai_strerror(int code);
#endif
#ifdef __CYGWIN__
int getaddrinfo(const char *nodename, const char  *servname,
    const struct addrinfo *hints, struct addrinfo **res);
void freeaddrinfo(struct addrinfo *ai);
#endif
#endif
